#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <socket.h>
#include <errno.h>
	
int
is_socket(int fd)
{
 int type, len;

 len = sizeof(type);
 if (getsockopt(fd, SOL_SOCKET, SO_TYPE, (void *)&type, (unsigned int*)&len) == 0)
 return 1;
 if (errno == ENOTSOCK) errno = 0;

 return 0;
}

#undef select
int
vms_select(int maxfd, fd_set *rfd, fd_set *wfd, fd_set *efd, struct timeval
*tv)
{
 int i, maxsock, socks, nsocks, ret;
 fd_set rs, ws, es, *rp, *wp, *ep;
 struct timeval z;

 FD_ZERO(&rs);
 FD_ZERO(&ws);
 FD_ZERO(&es);

 /* count socket and non-socket fds */
 maxsock = socks = nsocks = 0;
 if (rfd || wfd || efd) {
 for (i = 0; i < maxfd; ++i) {
 int r = (rfd != 0) && FD_ISSET(i, rfd);
 int w = (wfd != 0) && FD_ISSET(i, wfd);
 int e = (efd != 0) && FD_ISSET(i, efd);
 if (!r && !w && !e) continue;
 if (is_socket(i)) {
 if (r) FD_SET(i, (rp = &rs));
 if (w) FD_SET(i, (wp = &ws));
 if (e) FD_SET(i, (ep = &es));
 maxsock = i + 1;
 socks++;
 }
 else {
 nsocks++;
 }
 }
 }

 if (!nsocks) {
 /* sockets only */
 return select(maxsock, rfd, wfd, efd, tv);
 }

 if (!socks) {
 /* assuming non-socket fds are always ready */
 return nsocks;
 }

 /* check if sockets are ready */
 z.tv_sec = 0;
 z.tv_usec = 0;
 ret = select(maxsock, rp, wp, ep, &z);
 if (ret < 0) {
 if (rfd) *rfd = rs;
 if (wfd) *wfd = ws;
 if (efd) *efd = es;
 return nsocks;
 }

 for (i = 0; i < maxsock; ++i) {
 if (rp && FD_ISSET(i, rp)) {
 FD_SET(i, rfd);
 ret++;
 }
 if (wp && FD_ISSET(i, wp)) {
 FD_SET(i, wfd);
 ret++;
 }
 if (ep && FD_ISSET(i, ep)) {
 FD_SET(i, efd);
 ret++;
 }
 }

 return ret;
}
